/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Can_Target.h 599 2014-10-17 01:27:58Z shigihara $
 */

#ifndef TOPPERS_CAN_TARGET_H
#define TOPPERS_CAN_TARGET_H

#include "Can.h"
#include "prc_sil.h"


#define CANC_0_BASE		0x08020000U    /* CANȥ0Υ١ɥ쥹 */

#define EXTEND_CAN_ID_LENGTH	18U             /* ĥʬCAN-ID */
#define ACCEPTANCE_OFFSET		21U             /* ץ󥹥쥸Υեå */
#define NO_MASK_VAL				0x001FFFFFU     /* ץ󥹥ޥ쥸(ޥ̵) */

/* ⡼ɥ쥸 */
#define RESET_MODE			0x00000001U                                                                 /* ư⡼ɤRESET_MODEˤ */
#define OPERATING_MODE		0x00000000U                                                                 /* ư⡼ɤOPERATING_MODEˤ */
#define LISTEN_ONLY_MODE	0x00000002U                                                                 /* ػ */
#define NO_LISTEN_ONLY_MODE	0x00000000U                                                                 /*  */
#define NO_SEND_ACK_MODE	0x00000004U                                                                 /* ACKػ */
#define SEND_ACK_MODE		0x00000000U                                                                 /* ACK */
#define SINGLE_FILTER_MODE	0x00000008U                                                                 /* Single filter mode */
#define DUAL_FILTER_MODE	0x00000000U                                                                 /* Dual filter mode */
#define CANC_MODE_START		(OPERATING_MODE | NO_LISTEN_ONLY_MODE | SEND_ACK_MODE | SINGLE_FILTER_MODE) /* CANȥSTART */
#define CANC_MODE_STOP		(RESET_MODE     | NO_LISTEN_ONLY_MODE | SEND_ACK_MODE | SINGLE_FILTER_MODE) /* CANȥSTOP */

/* ׵ */
#define RECEIVE_IRQ			0x00000001U     /* λ */
#define TRANSMIT_IRQ		0x00000002U     /* λ */

#define IRQ_SET_DISABLE		0x00000000U     /* [ߵĥ쥸]׵ػ */
#define IRQ_SET_ENABLE		0x00000003U     /* [ߵĥ쥸]γ׵ */
#define TXABORT_CLEAR		0x0000FFFFU     /* [󥻥쥸]åܥå󥻥 */
#define TXCMP_CLEAR			0x0000FFFFU     /* [λ쥸]λӥåȥꥢ */
#define TXABORTCMP_CLEAR	0x0000FFFFU     /* [󥻥봰λ쥸]󥻥봰λӥåȥꥢ */
#define RXWAIT_OFF			0x00000000U     /* [ȥ쥸]ȽOFF */
#define RXCMP_CLEAR			0xFFFFFFFFU     /* [λ쥸]λӥåȥꥢ */
#define RXSELFREQ_CLEAR		0x00000000U     /* [ռ׵쥸]׵ʤ */
#define ERROR_CNT_CLEAR		0x00000060U     /* [顼󥿥쥸]顼󥿤ͤˤ */
#define BAUDRATE_250		0x80007F03U     /* [å桤Хߥ󥰥쥸]ܡ졼:250kbps */
#define BAUDRATE_500		0x80007F01U     /* [å桤Хߥ󥰥쥸]ܡ졼:500kbps */

#define MASK_CAN_ID_MASK	0x1FFFFFFFU     /* CanIdޥ */
#define MASK_4BIT			0x0000000FU     /* 4ӥåȥޥ */
#define MASK_8BIT			0x000000FFU     /* 8ӥåȥޥ */

/* ƥ쥸ޤǤΥեåȥɥ쥹 */
#define CANC_MODE_REG							0x0000U     /* ⡼ */
#define CANC_TXREQ_REG							0x0004U
#define CANC_TXABORT_REG						0x0008U     /* 󥻥쥸 */
#define CANC_TXCMP_REG							0x000CU
#define CANC_TXABORTCMP_REG						0x0010U
#define CANC_RXWAIT_REG							0x0014U
#define CANC_RXCMP_REG							0x0018U
#define CANC_RXOVERWRITE_REG					0x001CU
#define CANC_RXSELFREQ_REG						0x0020U
#define CANC_STATUS_REG							0x0024U
#define CANC_IRQ_REG							0x0028U
#define CANC_IRQ_EN_REG							0x002CU     /* ߵĥ쥸 */
#define CANC_IRQ_RXEN_REG						0x0030U
#define CANC_CLKDIV_BUSTIM_REG					0x0034U     /* å桤Хߥ */
#define CANC_ACCEPTANCE_CODE_REG				0x0038U     /* ץ󥹥ɥ쥸 */
#define CANC_ACCEPTANCE_MASK_REG				0x003CU     /* ץ󥹥ޥ쥸 */
#define CANC_ARBITRATION_LOST_CAPTURE_REG		0x0040U
#define CANC_ERROR_CAPTURE_CODE_REG				0x0044U
#define CANC_ERROR_CNT_REG						0x0048U
#define CANC_MBOXWIN_REG						0x004CU     /* åܥåɥ쥸 */
#define CANC_RXMBOX_ACCEPTANCE_CODE_REG			0x0070U     /* åܥåΥץ󥹥ɥ쥸 */
#define CANC_RXMBOX_ACCEPTANCE_MASK_REG			0x0074U     /* åܥåΥץ󥹥ޥ쥸 */
#define CANC_TXMBOX_DATA0_REG					0x0100U
#define CANC_TXMBOX_DATA1_REG					0x0104U
#define CANC_TXMBOX_DATA2_REG					0x0108U
#define CANC_TXMBOX_DATA3_REG					0x010CU
#define CANC_RXMBOX_DATA0_REG					0x0200U
#define CANC_RXMBOX_DATA1_REG					0x0204U
#define CANC_RXMBOX_DATA2_REG					0x0208U
#define CANC_RXMBOX_DATA3_REG					0x020CU

#define SIL_REW_IOP_CANC_0_BASE(mem)		sil_rew_iop((void *) (CANC_0_BASE + (mem)))
#define SIL_WRW_IOP_CANC_0_BASE(mem, data)	sil_wrw_iop((void *) (CANC_0_BASE + (mem)), (data))

/* ɼѥ쥸ޥ */
#define CANC_RD_MODE_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_MODE_REG)
#define CANC_RD_TXCMP_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_TXCMP_REG)
#define CANC_RD_TXABORTCMP_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_TXABORTCMP_REG)
#define CANC_RD_RXCMP_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_RXCMP_REG)
#define CANC_RD_RXOVERWRITE_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_RXOVERWRITE_REG)
#define CANC_RD_STATUS_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_STATUS_REG)
#define CANC_RD_IRQ_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_IRQ_REG)
#define CANC_RD_CLKDIV_BUSTIM_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_CLKDIV_BUSTIM_REG)
#define CANC_RD_ERROR_CNT_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_ERROR_CNT_REG)
#define CANC_RD_RXMBOX_DATA0_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA0_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA1_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA1_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA2_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA2_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA3_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA3_REG + (0x0010U * (box_num))))

/* ѥ쥸ޥ */
#define CANC_WR_MODE_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_MODE_REG, data)
#define CANC_WR_TXREQ_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_TXREQ_REG, data)
#define CANC_WR_TXABORT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_TXABORT_REG, data)
#define CANC_WR_TXCMP_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_TXCMP_REG, data)
#define CANC_WR_TXABORTCMP_REG(data)				SIL_WRW_IOP_CANC_0_BASE(CANC_TXABORTCMP_REG, data)
#define CANC_WR_RXWAIT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_RXWAIT_REG, data)
#define CANC_WR_RXCMP_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_RXCMP_REG, data)
#define CANC_WR_RXSELFREQ_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_RXSELFREQ_REG, data)
#define CANC_WR_IRQ_EN_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_IRQ_EN_REG, data)
#define CANC_WR_IRQ_RXEN_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_IRQ_RXEN_REG, data)
#define CANC_WR_CLKDIV_BUSTIM_REG(data)				SIL_WRW_IOP_CANC_0_BASE(CANC_CLKDIV_BUSTIM_REG, data)
#define CANC_WR_ACCEPTANCE_CODE_REG(data)			SIL_WRW_IOP_CANC_0_BASE(CANC_ACCEPTANCE_CODE_REG, data)
#define CANC_WR_ACCEPTANCE_MASK_REG(data)			SIL_WRW_IOP_CANC_0_BASE(CANC_ACCEPTANCE_MASK_REG, data)
#define CANC_WR_ERROR_CNT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_ERROR_CNT_REG, data)
#define CANC_WR_MBOXWIN_REG(box_num)				SIL_WRW_IOP_CANC_0_BASE(CANC_MBOXWIN_REG, ((box_num) << 16))
#define CANC_WR_RXMBOX_ACCEPTANCE_CODE_REG(data)	SIL_WRW_IOP_CANC_0_BASE(CANC_RXMBOX_ACCEPTANCE_CODE_REG, data)
#define CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(data)	SIL_WRW_IOP_CANC_0_BASE(CANC_RXMBOX_ACCEPTANCE_MASK_REG, data)
#define CANC_WR_TXMBOX_DATA0_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA0_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA1_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA1_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA2_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA2_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA3_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA3_REG + (0x0010U * (box_num))), data)

/*
 * [CAN077][CAN284][CAN385][CAN386] åȰ¸
 */
#define BYTE_LENGTH		4U

extern const CAN_CTRL_INIB	*p_cur_can_ctrl_inib_table;
extern uint8				can_interrupt_nested_cnt[];

/* ؿץȥ */
LOCAL_INLINE boolean can_target_init_unit_phase1(const Can_ConfigType *p_can_config);
LOCAL_INLINE boolean can_target_init_controller_phase1(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_init_controller_phase2(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_init_controller_phase3(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_rbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hrh_idx);
LOCAL_INLINE boolean can_target_tbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hth_idx);
LOCAL_INLINE boolean can_target_init_unit_phase2(const Can_ConfigType *p_can_config);
LOCAL_INLINE boolean can_target_change_baudrate(uint8 ctrl_id, const Can_ControllerBaudrateConfigType *p_baudrate_table);
LOCAL_INLINE boolean can_target_start_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_stop_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_sleep_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_wakeup_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib);
LOCAL_INLINE boolean can_target_disable_controller_interrupts(uint8 ctrl_id);
LOCAL_INLINE boolean can_target_enable_controller_interrupts(uint8 ctrl_id);
LOCAL_INLINE boolean can_target_check_wakeup(uint8 ctrl_id);
LOCAL_INLINE Can_ReturnType can_target_transmit(uint8 ctrl_id, uint8 mb_idx, const Can_PduType *PduInfo);
LOCAL_INLINE boolean can_target_check_and_get_rbox(uint8 ctrl_id, Can_HwHandleType *p_rbox_idx);
LOCAL_INLINE boolean can_target_get_rdata(uint8 ctrl_id, Can_HwHandleType rbox_id, Can_IdType *p_can_id, uint8 *p_can_dlc, uint8 can_sdu[]);
LOCAL_INLINE boolean can_target_check_and_get_tbox(uint8 ctrl_id, Can_HwHandleType *p_tbox_idx);
LOCAL_INLINE Can_StateTransitionType can_target_get_mode(uint8 ctrl_id);
LOCAL_INLINE void can_target_busy_wait(void);

/* [CAN407] Can_Initunit_phase1 */
LOCAL_INLINE boolean
can_target_init_unit_phase1(const Can_ConfigType *p_can_config)
{
	/* ˥åȤ˴ؤ̵ */
	return(TRUE);
}

/* [CAN407] Can_Initcontroller_phase1 */
LOCAL_INLINE boolean
can_target_init_controller_phase1(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* [CAN259] ȥ߾֤ǽ */
	CANC_WR_MODE_REG(CANC_MODE_STOP);

	return(TRUE);
}

/* [CAN407] Can_Initcontroller_phase2 */
LOCAL_INLINE boolean
can_target_init_controller_phase2(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* ߶ػ */
	can_target_disable_controller_interrupts(ctrl_id);

	/* ץ󥹥ե륿 */
	/* ΤΥץ󥹥ɥ쥸(Ƶ) */
	CANC_WR_ACCEPTANCE_CODE_REG(0xFFFFFFFFU);

	/* ΤΥץ󥹥ޥ쥸(Ƶ) */
	CANC_WR_ACCEPTANCE_MASK_REG(0xFFFFFFFFU);

	return(TRUE);
}

/* [CAN407] Can_Initcontroller_phase3 */
LOCAL_INLINE boolean
can_target_init_controller_phase3(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	uint8	i;
	uint32	irq_rxen_reg_set_bit = 1U;
	uint32	bit_offset = 1U;

	/* [CAN236][CAN237][CAN419] 쥸ν */
	/* ̤Υå򥭥󥻥뤹 */
	CANC_WR_TXABORT_REG(TXABORT_CLEAR);

	/* 顼󥿥쥸ͤ(Ȥͤ0̵硤顼󥿤ѹԲ) */
	CANC_WR_ERROR_CNT_REG(ERROR_CNT_CLEAR);

	/* ׵쥸׵̵ˤ */
	CANC_WR_RXSELFREQ_REG(RXSELFREQ_CLEAR);

	/* ȥ쥸򥦥Ƚդˤ */
	CANC_WR_RXWAIT_REG(RXWAIT_OFF);

	/* λ쥸̤λˤ */
	CANC_WR_TXCMP_REG(TXCMP_CLEAR);

	/* 󥻥봰λ쥸󥻥̤λˤ */
	CANC_WR_TXABORTCMP_REG(TXABORTCMP_CLEAR);

	/* λ쥸ǡ̵ˤ */
	CANC_WR_RXCMP_REG(RXCMP_CLEAR);

	/* С饤ȥ쥸̤ȯˤ */
	CANC_RD_RXOVERWRITE_REG();

	/* ߵĥ쥸ߵĤˤ */
	for (i = 0U; i < p_ctrl_inib->tnum_hrh; i++) {
		CANC_WR_IRQ_RXEN_REG(irq_rxen_reg_set_bit);
		irq_rxen_reg_set_bit <<= bit_offset;
		irq_rxen_reg_set_bit += bit_offset;
	}

	/* ׵쥸̤ȯˤ */
	CANC_RD_IRQ_REG();

	return(TRUE);
}

/* [CAN407] Can_Init᡼ܥå */
LOCAL_INLINE boolean
can_target_rbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hrh_idx)
{
	uint32	can_id_reg;
	uint32	filtermask_val;

	/* оݤꤹ */
	CANC_WR_MBOXWIN_REG(hrh_idx);

	/* ƼåܥåΥץ󥹥ɥ쥸 */
	can_id_reg = ((uint32) GET_RBOX_CAN_ID(ctrl_id, hrh_idx)) << ACCEPTANCE_OFFSET;
	CANC_WR_RXMBOX_ACCEPTANCE_CODE_REG(can_id_reg);

	/* оݤμåܥåΥե륿ޥ̵ͭȽ */
	if (GET_RBOX_FILTER_MASK_IDX(ctrl_id, hrh_idx) != CAN_NO_MASK_IDX) {
		/* оݤΥե륿ޥ */
		filtermask_val = ((uint32) p_ctrl_inib->p_filtermask_table[hrh_idx]) << ACCEPTANCE_OFFSET;
		CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(filtermask_val);
	}
	else {
		/* оݤΥե륿ޥͤCAN_NO_MASK_IDX */
		CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(NO_MASK_VAL);
	}

	return(TRUE);
}

/* [CAN407] Can_Init᡼ܥå */
LOCAL_INLINE boolean
can_target_tbox_initialize(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib, Can_HwHandleType hth_idx)
{
	return(TRUE);
}

/* [CAN407] Can_Initunit_phase2 */
LOCAL_INLINE boolean
can_target_init_unit_phase2(const Can_ConfigType *p_can_config)
{
	/* ˥åȤ˴ؤ̵ */
	return(TRUE);
}

/* Can_ChangeBaudrate */
LOCAL_INLINE boolean
can_target_change_baudrate(uint8 ctrl_id, const Can_ControllerBaudrateConfigType *p_baudrate_table)
{
	/* [CAN255] ܡ졼Ȥ */
	if (p_baudrate_table->CanControllerBaudRate == 250U) {
		CANC_WR_CLKDIV_BUSTIM_REG(BAUDRATE_250);
	}
	else {
		CANC_WR_CLKDIV_BUSTIM_REG(BAUDRATE_500);
	}

	return(TRUE);
}

/* Can_SetControllerModeCAN_T_START */
LOCAL_INLINE boolean
can_target_start_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* [CAN261] ⡼ؽ */
	CANC_WR_MODE_REG(CANC_MODE_START);

	/* [CAN204][CAN425] ߶ػߥͥȥȽ */
	if (can_interrupt_nested_cnt[ctrl_id] == 0U) {
		/* [CAN196] ߵĽ */
		can_target_enable_controller_interrupts(ctrl_id);
	}

	return(TRUE);
}

/* Can_SetControllerModeCAN_T_STOP */
LOCAL_INLINE boolean
can_target_stop_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* [CAN204][CAN426] ߶ػߥͥȥȽ */
	if (can_interrupt_nested_cnt[ctrl_id] == 0U) {
		/* [CAN197] ߶ػ߽ */
		can_target_disable_controller_interrupts(ctrl_id);
	}

	/* [CAN263] ⡼ؽ */
	CANC_WR_MODE_REG(CANC_MODE_STOP);

	return(TRUE);
}

/* Can_SetControllerModeCAN_T_SLEEP */
LOCAL_INLINE boolean
can_target_sleep_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* CAN_T_SLEEP̤ݡ */
	return(FALSE);
}

/* Can_SetControllerModeCAN_T_WAKEUP */
LOCAL_INLINE boolean
can_target_wakeup_controller_and_change_interrupt(uint8 ctrl_id, const CAN_CTRL_INIB *p_ctrl_inib)
{
	/* CAN_T_WAKEUP̤ݡ */
	return(FALSE);
}

/* Can_DisableControllerInterrupts */
LOCAL_INLINE boolean
can_target_disable_controller_interrupts(uint8 ctrl_id)
{
	/* ߶ػ߽ */
	CANC_WR_IRQ_EN_REG(IRQ_SET_DISABLE);

	return(TRUE);
}

/* Can_EnableControllerInterrupts */
LOCAL_INLINE boolean
can_target_enable_controller_interrupts(uint8 ctrl_id)
{
	/* ߵĽ */
	CANC_WR_IRQ_EN_REG(IRQ_SET_ENABLE);

	return(TRUE);
}

/* Can_CheckWakeup */
LOCAL_INLINE boolean
can_target_check_wakeup(uint8 ctrl_id)
{
	/* åפ̤ݡ */
	return(FALSE);
}

/* Can_Writeǡڤ׵ */
LOCAL_INLINE Can_ReturnType
can_target_transmit(uint8 ctrl_id, uint8 mb_idx, const Can_PduType *PduInfo)
{
	uint8	i, j;
	uint32	temp_data1 = 0;         /* ǡ(14byte)Ǽ */
	uint32	temp_data2 = 0;         /* ǡ(58byte)Ǽ */
	uint32	request_bit;

	if (PduInfo->length > BYTE_LENGTH) {
		/* 58byteΥǡ򥳥ԡ */
		for (i = 0U; i < (PduInfo->length - BYTE_LENGTH); i++) {
			if (i > 0U) {
				temp_data2 = temp_data2 << 8U;
			}
			temp_data2 = (temp_data2 | PduInfo->sdu[PduInfo->length - (1U + i)]);
		}
	}
	else {
		i = 0U;
	}

	/* åΥǡ1byteʾʤ顤1byteܰʹߤ */
	if (PduInfo->length > 0) {
		/* 14byteΥǡ򥳥ԡ */
		for (j = i; j < PduInfo->length; j++) {
			if (j > i) {
				temp_data1 = temp_data1 << 8U;
			}
			temp_data1 = (temp_data1 | PduInfo->sdu[PduInfo->length - (1U + j)]);
		}
	}

	/* CAN-IDγǼ */
	CANC_WR_TXMBOX_DATA0_REG((PduInfo->id << EXTEND_CAN_ID_LENGTH), mb_idx);

	/* ǡĹγǼ */
	CANC_WR_TXMBOX_DATA1_REG(PduInfo->length, mb_idx);

	/* [CAN059][CAN427] ǡǼ */
	if (PduInfo->length > 0) {
		/* ǡ(14)γǼ */
		CANC_WR_TXMBOX_DATA2_REG(temp_data1, mb_idx);
	}
	/* ǡ5byteʾʤǼ */
	if (PduInfo->length > BYTE_LENGTH) {
		/* ǡ(58)γǼ */
		CANC_WR_TXMBOX_DATA3_REG(temp_data2, mb_idx);
	}

	/* ׵ */
	request_bit = 1U << mb_idx;
	CANC_WR_TXREQ_REG(request_bit);

	return(CAN_OK);
}

/* Can_IsrRx᡼ܥå */
LOCAL_INLINE boolean
can_target_check_and_get_rbox(uint8 ctrl_id, Can_HwHandleType *p_rbox_idx)
{
	boolean	ret;
	uint8	i;
	uint32	cmp_reg;

	/* HRH(DETǥ顼ΤǤ褦0xFFǽ) */
	*p_rbox_idx = 0xFFU;

	/* λ */
	cmp_reg = CANC_RD_RXCMP_REG();

	/* å̵ͭȽ */
	if (cmp_reg != 0x00000000U) {
		for (i = 0U; i < GET_HRH_NUM(ctrl_id); i++) {
			if ((cmp_reg & 1U) != 0U) {

				/* HRH */
				*p_rbox_idx = i;
				break;
			}
			else {
				cmp_reg >>= 1U;
			}
		}
		/* åͭ */
		ret = TRUE;
	}
	else {
		/* å̵ */
		ret = FALSE;
	}

	return(ret);
}

/* Can_IsrRxIDΥǡ */
LOCAL_INLINE boolean
can_target_get_rdata(uint8 ctrl_id, Can_HwHandleType rbox_id, Can_IdType *p_can_id, uint8 *p_can_dlc, uint8 can_sdu[])
{
	uint8	j;
	uint8	local_can_dlc;
	uint32	temp_data;
	uint32	clear_bit;

	/* λꥢӥå */
	clear_bit = 1U;
	clear_bit <<= (uint32) rbox_id;

	/* CAN-IDФ */
	*p_can_id = ((CANC_RD_RXMBOX_DATA0_REG(rbox_id) &MASK_CAN_ID_MASK) >> EXTEND_CAN_ID_LENGTH);

	/* DLCμФ */
	local_can_dlc = (uint8) (CANC_RD_RXMBOX_DATA1_REG(rbox_id) &MASK_4BIT);
	*p_can_dlc = local_can_dlc;

	/* [CAN012][CAN060][CAN299][CAN300] ǡФ*/
	if (local_can_dlc > BYTE_LENGTH) {
		/* 5byteʾξ硤5byteܰʹߤΥ쥸ɤ߹ */
		/* SDU(14byte)μФ */
		temp_data = CANC_RD_RXMBOX_DATA2_REG(rbox_id);
		for (j = 0U; j < BYTE_LENGTH; j++) {
			can_sdu[j] = (uint8) (temp_data & MASK_8BIT);
			temp_data >>= 8U;
		}
		/* SDU(58byte)μФ */
		temp_data = CANC_RD_RXMBOX_DATA3_REG(rbox_id);
		for (j = BYTE_LENGTH; j < local_can_dlc; j++) {
			can_sdu[j] = (uint8) (temp_data & MASK_8BIT);
			temp_data >>= 8U;
		}
	}
	else {
		/* 4byteʲξ硤5byteܰʹߤΥ쥸ɤ߹ޤʤ */
		/* SDU(14byte)μФ */
		temp_data = CANC_RD_RXMBOX_DATA2_REG(rbox_id);
		for (j = 0U; j < local_can_dlc; j++) {
			can_sdu[j] = (uint8) (temp_data & MASK_8BIT);
			temp_data >>= 8U;
		}
	}

	/* [CAN420] λӥåȥꥢ */
	CANC_WR_RXCMP_REG(clear_bit);

	return(TRUE);
}

/* Can_IsrTx᡼ܥåå */
LOCAL_INLINE boolean
can_target_check_and_get_tbox(uint8 ctrl_id, Can_HwHandleType *p_tbox_idx)
{
	boolean	ret;
	uint8	i;
	uint32	cmp_reg;
	uint32	clear_bit;

	/* HTH(DETǥ顼ΤǤ褦0xFFǽ) */
	*p_tbox_idx = 0xFFU;

	/* λꥢӥå */
	clear_bit = 1U;

	/* λ */
	cmp_reg = CANC_RD_TXCMP_REG();

	/* å̵ͭȽ */
	if (cmp_reg != 0x00000000U) {
		for (i = 0U; i < GET_HTH_NUM(ctrl_id); i++) {
			if ((cmp_reg & 1U) != 0U) {
				/* [CAN420] λӥåȤΥꥢ */
				CANC_WR_TXCMP_REG(clear_bit);

				/* HTH */
				*p_tbox_idx = i;
				break;
			}
			else {
				cmp_reg >>= 1U;
				clear_bit <<= 1U;
			}
		}
		/* åͭ */
		ret = TRUE;
	}
	else {
		/* å̵ */
		ret = FALSE;
	}

	return(ret);
}

LOCAL_INLINE Can_StateTransitionType
can_target_get_mode(uint8 ctrl_id)
{
	Can_StateTransitionType	ret;
	uint32					mode_reg;

	/* ư⡼ɼ */
	mode_reg = CANC_RD_MODE_REG();

	/* [CAN384][CAN409][CAN410] ư⡼Ƚ */
	if (mode_reg == CANC_MODE_START) {
		ret = CAN_T_START;
	}
	else {
		ret = CAN_T_STOP;
	}

	return(ret);
}

LOCAL_INLINE void
can_target_busy_wait(void)
{
	volatile uint32 i;

	/* ӥȽ */
	for (i = 0U; i < 100000U; i++) {
	}
}

/*
 *  ¸Ǥ̤ݡȵǽ
 *    <CAN048><CAN294><CAN361><CAN461> åפ̤ݡȤΤᡤбʤ
 *    <CAN257><CAN265><CAN267><CAN411><CAN412> ϡɥSLEEP⡼ɤ̤ݡȤΤᡤбʤ
 *    <CAN282><CAN283> 󥻥̤ݡȤΤᡤбʤ
 *    <CAN238><CAN242><CAN391><CAN244> nios2Ǥ̤ݡȤΤᡤбʤ
 *    <CAN258><CAN290><CAN404><CAN405>ŪSLEEP⡼ɤ̤ݡȤΤᡤбʤ
 *    <CAN062><CAN256><CAN260><CAN422><CAN453> ܡ졼ȤϸΤᡤбʤ
 *    <CAN272><CAN273><CAN274> Хս̤ݡȤΤᡤбʤ
 *    <CAN239> I/OݡȤνOS¦бƤ뤿ᡤ¸Ǥбʤ
 */

#endif /* TOPPERS_CAN_TARGET_H */
